

import java.io.*;
import java.net.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

@SuppressWarnings("unused")
public class SocketConnection extends Thread {
	Socket requestSocket;
	ObjectOutputStream out;
 	ObjectInputStream in;
 	String message;
 	List<String> places = new ArrayList<String>();
	@SuppressWarnings({ "unchecked" })
	
	public void run()
	{
		try{
			requestSocket = new Socket("139.78.140.249", 9000);
			out = new ObjectOutputStream(requestSocket.getOutputStream());
			out.flush();
			in = new ObjectInputStream(requestSocket.getInputStream());
				try{
					places=(List<String>)in.readObject();
					int size=places.size();
					while(!((places.size()%5)==0))
					{
						places.add("0");
					}
					//Shuffle all the IP address of Vuze clients and other Machines
					Collections.shuffle(places);
					//Ping 5 Machines at a time using daemon threads
					for(int k=0;k<places.size();k=k+5)
					{
						pingPeer p = new pingPeer(places.get(k));
						p.setDaemon(true);
						p.start();
						pingPeer p1 = new pingPeer(places.get(k+1));
						p1.setDaemon(true);
						p1.start();
						pingPeer p2 = new pingPeer(places.get(k+2));
						p2.setDaemon(true);
						p2.start();
						pingPeer p3 = new pingPeer(places.get(k+3));
						p3.setDaemon(true);
						p3.start();
						pingPeer p4 = new pingPeer(places.get(k+4));
						p4.setDaemon(true);
						p4.start();
						//Kill all the ping threads created after 2 seconds
						try {
							Thread.sleep(2000);
							if(p.isAlive())
							{
								p.interrupt();
							}if (p1.isAlive())
							{
								p1.interrupt();
							}if (p2.isAlive())
							{
								p2.interrupt();
							}if (p3.isAlive())
							{
								p3.interrupt();
							}
							if (p4.isAlive())
							{
								p4.interrupt();
							}
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
					
					out.writeObject(AizenPlugin.responseTimes);
					out.flush();
				}
				catch(ClassNotFoundException classNot){
					System.err.println("data received in unknown format");
				}
		}
		catch(UnknownHostException unknownHost){
			System.err.println("You are trying to connect to an unknown host!");
		}
		catch(IOException ioException){
			ioException.printStackTrace();
		}
		finally{
			try{
				in.close();
				out.close();
				requestSocket.close();
			}
			catch(IOException ioException){
				ioException.printStackTrace();
			}
		}
	}
	
}